package input;

/**
 * Prsentation simplifiee d'un attribut.
 * Ils sont publiques, sans valeur initiales
 * @author jroyer
 *
 */
public class Attribute {
	
	/**
	 * Le type.
	 */
	protected String type;
	
	/**
	 * Le nom de l'attribut.
	 */
	protected String name;
	
	/**
	 * La visbilit.
	 */
	protected Scope scope;
	
	/**
	 * Indicateur des accesseurs
	 */
	protected Gener gener;
	
	/**
	 * Constructeur d'attribut.
	 * @param tp type
	 * @param n nom
	 * @param s la visibilit
	 */
	public Attribute(String tp, String n, Scope s, Gener g) {
		this.type = tp;
		this.name = n;
		this.scope = s;
		this.gener = g;
	}

	/**
	 * 
	 * @return genere le code.
	 */
	public String generate() {
		return Keywords.TAB + Keywords.COMMENT 
				+ "L'attribut " + this.getName() + Keywords.NEWLINE
				+ Keywords.TAB + this.scope.generate() + this.getType() + Keywords.BLANC 
				+ this.getName() + Keywords.SEMICOLON + Keywords.NEWLINE;
		
	}
	
	/**
	 * 
	 * @return genere un parametre correspondant.
	 */
	public String generateParameter() {
		return this.getType() + Keywords.BLANC + this.getName();
	}
	
	/**
	 * generation des accesseurs 
	 * @return
	 */
	public String generateAccessors() {
		if ((this.scope != Scope.PUBLIC) && (this.gener != Gener.NO)) {
			switch (this.gener) {
			case GET : return this.generateGetter();
			case SET : return this.generateSetter();
			case GETSET : return this.generateGetSet();
			default : return "";
			}
		} else {
			return "";
		}
	}
	
	/**
	 * Generation du getter
	 * @return
	 */
	public String generateGetter() {
		// le commentaire
		String towrite = Keywords.TAB + Keywords.COMMENT +
		         " Getter for " + this.name + " attribute." + Keywords.NEWLINE;
		// la declaration + visibilite
		towrite += Keywords.TAB + Keywords.PUBLIC;
		towrite += this.getType() + Keywords.BLANC +
		// accessor name
		"get" + Character.toUpperCase(this.name.charAt(0)) + this.name.substring(1) 
				+ Keywords.PARIN;
		towrite += Keywords.PAROUT + Keywords.ACCIN + Keywords.NEWLINE;
		towrite += Keywords.TAB + Keywords.TAB + "return this." + this.name
				+ Keywords.SEMICOLON + Keywords.NEWLINE;
		towrite += Keywords.TAB + Keywords.ACCOUT;
		return towrite;
	}
	
	/**
	 * Generation du setter.
	 * @return
	 */
	public String generateSetter() {
		// le commentaire
		String towrite = Keywords.TAB + Keywords.COMMENT +
		        " Setter for " + this.name + " attribute." + Keywords.NEWLINE;
		// la declaration + visibilite
		towrite += Keywords.TAB + Keywords.PUBLIC + Keywords.VOID + Keywords.BLANC;
		// accessor name
		towrite += "set" + Character.toUpperCase(this.name.charAt(0)) + this.name.substring(1);
		// parameter 
		towrite +=	 Keywords.PARIN + this.getType() + Keywords.BLANC+ Keywords.OTHER + Keywords.PAROUT;
		towrite +=  Keywords.ACCIN + Keywords.NEWLINE;
		towrite += Keywords.TAB + Keywords.TAB + Keywords.THIS + Keywords.DOT + this.name 
				+ Keywords.SET + Keywords.OTHER + Keywords.SEMICOLON + Keywords.NEWLINE;
		towrite += Keywords.TAB + Keywords.ACCOUT;
		return towrite;
	}
	
	/**
	 * Generation des deux get et set.
	 * @return
	 */
	public String generateGetSet() {
		return this.generateGetter()
				+ Keywords.NEWLINE + Keywords.NEWLINE +
				this.generateSetter();
	}
	
	/**
	 * 
	 * @return le type.
	 */
	public String getType() {
		return type;
	}

	/**
	 * Affecte le type.
	 * @param type une chaine
	 */
	public void setType(final String type) {
		this.type = type;
	}

	/**
	 * 
	 * @return le nom.
	 */
	public String getName() {
		return name;
	}

	/**
	 * Affecte le nom.
	 * @param name une chaine
	 */
	public void setName(final String name) {
		this.name = name;
	}
	
	/**
	 * @return converion en chaine.
	 */
	public String toString() {
		return this.getName() + ":" + this.getType();
	}

}
